﻿using System.Collections;
using UnityEngine;
using UnityEngine.UI;
using TMPro;
using UnityEngine.Video;
using Newtonsoft.Json;
using System;
using System.Linq;
using Steamworks;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Collections.Generic;
using System.Reflection;
using System.Runtime.Serialization;
using System.Threading.Tasks;
using YoutubeExplode;
using YoutubeExplode.Videos.Streams;
using Debug = UnityEngine.Debug;
using System.Threading;
using Newtonsoft.Json.Linq;
using System.Net;
using System.Text;
using HMLLibrary;
using System.Security.Cryptography.Xml;

public class CinemaMod : Mod
{
    public static GameObject menu;
    public static bool isMenuShown;
    public static CinemaScreen currentScreen;
    public static AssetBundle assetbundle;
    public static Material novideoMaterial;
    public static CinemaMod instance;

    AssetBundleRequest request = null;

    List<string> customAssemblies = new List<string>();
    public List<Assembly> additional = new List<Assembly>();

    IEnumerator Start()
    {
        delayWorldLoading = true;
        customAssemblies.Add(@"Assemblies/" + "AngleSharp.dll");
        customAssemblies.Add(@"Assemblies/" + "Microsoft.Bcl.AsyncInterfaces.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Buffers.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Memory.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Numerics.Vectors.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Runtime.CompilerServices.Unsafe.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Text.Encoding.CodePages.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Text.Encodings.Web.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Text.Json.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Threading.Tasks.Extensions.dll");
        customAssemblies.Add(@"Assemblies/" + "System.ValueTuple.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Diagnostics.DiagnosticSource.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Net.Http.dll");
        customAssemblies.Add(@"Assemblies/" + "System.Xml.Linq.dll");
        customAssemblies.Add(@"Assemblies/" + "YoutubeExplode.dll");


        foreach (var assemblyName in customAssemblies)
        {
            try
            {
                //Debug.Log("Trying to load " + assemblyName);
                var bytes = GetEmbeddedFileBytes(assemblyName);

                var assembly = Assembly.Load(bytes);
                additional.Add(assembly);
            }
            catch (Exception e)
            {
                Debug.LogWarning(@"Couldn't load assembly because: " + e);
            }
        }

        AppDomain.CurrentDomain.AssemblyResolve += (x, y) =>
        {
            var name = new AssemblyName(y.Name).Name;
            foreach (var a in additional)
                if (a.GetName().Name == name)
                    return a;
            return null;
        };

        instance = this;
        HNotification notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.spinning, "Loading CinemaMod...");

        var bundleLoadRequest = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("cinemamod.assets"));
        yield return bundleLoadRequest;
        assetbundle = bundleLoadRequest.assetBundle;

        request = assetbundle.LoadAssetAsync<Material>("Black");
        yield return request;
        novideoMaterial = request.asset as Material;

        request = assetbundle.LoadAssetAsync<GameObject>("MenuCanvas");
        yield return request;
        GameObject MenuCanvas = request.asset as GameObject;

        menu = Instantiate(MenuCanvas, transform);
        menu.GetComponent<CanvasGroup>().alpha = 0;
        menu.GetComponent<CanvasGroup>().interactable = false;
        menu.GetComponent<CanvasGroup>().blocksRaycasts = false;
        menu.transform.Find("Background").Find("TopBar").Find("CloseButton").GetComponent<Button>().onClick.AddListener(CloseCinemaMenu);
        menu.transform.Find("Background").Find("PlayButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            if (currentScreen != null)
            {
                currentScreen.Play();
                MessageHandler.SendMessage(new CMessage_CinemaModPosition((Messages)MessageHandler.NetworkMessages.CinemaMod_Play, currentScreen.transform.position));
            }
        });
        menu.transform.Find("Background").Find("PauseButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            if (currentScreen != null)
            {
                currentScreen.Pause();
                MessageHandler.SendMessage(new CMessage_CinemaModPosition((Messages)MessageHandler.NetworkMessages.CinemaMod_Pause, currentScreen.transform.position));
            }
        });
        menu.transform.Find("Background").Find("StopButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            if (currentScreen != null)
            {
                currentScreen.Stop();
                MessageHandler.SendMessage(new CMessage_CinemaModPosition((Messages)MessageHandler.NetworkMessages.CinemaMod_Stop, currentScreen.transform.position));
            }
        });

        request = assetbundle.LoadAssetAsync<Item_Base>("raftsungtv_item");
        yield return request;
        Item_Base TV = request.asset as Item_Base;
        TV.settings_buildable.GetBlockPrefab(0).gameObject.AddComponent<CinemaScreen>();
        TV.settings_buildable.GetBlockPrefab(1).gameObject.AddComponent<CinemaScreen>();
        RAPI.RegisterItem(TV);
        RAPI.AddItemToBlockQuadType(TV, RBlockQuadType.quad_floor);
        RAPI.AddItemToBlockQuadType(TV, RBlockQuadType.quad_foundation);
        RAPI.AddItemToBlockQuadType(TV, RBlockQuadType.quad_table);
        RAPI.AddItemToBlockQuadType(TV, RBlockQuadType.quad_wall);

        request = assetbundle.LoadAssetAsync<Item_Base>("laptoppc_item");
        yield return request;
        Item_Base LaptopPC = request.asset as Item_Base;
        LaptopPC.settings_buildable.GetBlockPrefab(0).gameObject.AddComponent<CinemaScreen>();
        RAPI.RegisterItem(LaptopPC);
        RAPI.AddItemToBlockQuadType(LaptopPC, RBlockQuadType.quad_floor);
        RAPI.AddItemToBlockQuadType(LaptopPC, RBlockQuadType.quad_foundation);
        RAPI.AddItemToBlockQuadType(LaptopPC, RBlockQuadType.quad_table);

        request = assetbundle.LoadAssetAsync<Item_Base>("pcscreen_item");
        yield return request;
        Item_Base PCScreen = request.asset as Item_Base;
        PCScreen.settings_buildable.GetBlockPrefab(0).gameObject.AddComponent<CinemaScreen>();
        RAPI.RegisterItem(PCScreen);
        RAPI.AddItemToBlockQuadType(PCScreen, RBlockQuadType.quad_floor);
        RAPI.AddItemToBlockQuadType(PCScreen, RBlockQuadType.quad_foundation);
        RAPI.AddItemToBlockQuadType(PCScreen, RBlockQuadType.quad_table);

        request = assetbundle.LoadAssetAsync<Item_Base>("oldtv_item");
        yield return request;
        Item_Base OldTV = request.asset as Item_Base;
        OldTV.settings_buildable.GetBlockPrefab(0).gameObject.AddComponent<CinemaScreen>();
        RAPI.RegisterItem(OldTV);
        RAPI.AddItemToBlockQuadType(OldTV, RBlockQuadType.quad_floor);
        RAPI.AddItemToBlockQuadType(OldTV, RBlockQuadType.quad_foundation);
        RAPI.AddItemToBlockQuadType(OldTV, RBlockQuadType.quad_table);

        request = assetbundle.LoadAssetAsync<Item_Base>("largeraftsungtv_item");
        yield return request;
        Item_Base LargeTV = request.asset as Item_Base;
        LargeTV.settings_buildable.GetBlockPrefab(0).gameObject.AddComponent<CinemaScreen>();
        LargeTV.settings_buildable.GetBlockPrefab(1).gameObject.AddComponent<CinemaScreen>();
        RAPI.RegisterItem(LargeTV);
        RAPI.AddItemToBlockQuadType(LargeTV, RBlockQuadType.quad_floor);
        RAPI.AddItemToBlockQuadType(LargeTV, RBlockQuadType.quad_foundation);
        RAPI.AddItemToBlockQuadType(LargeTV, RBlockQuadType.quad_table);
        RAPI.AddItemToBlockQuadType(LargeTV, RBlockQuadType.quad_wall);

        request = assetbundle.LoadAssetAsync<Item_Base>("xlraftsungtv_item");
        yield return request;
        Item_Base XLTV = request.asset as Item_Base;
        XLTV.settings_buildable.GetBlockPrefab(0).gameObject.AddComponent<CinemaScreen>();
        XLTV.settings_buildable.GetBlockPrefab(1).gameObject.AddComponent<CinemaScreen>();
        RAPI.RegisterItem(XLTV);
        RAPI.AddItemToBlockQuadType(XLTV, RBlockQuadType.quad_floor);
        RAPI.AddItemToBlockQuadType(XLTV, RBlockQuadType.quad_foundation);
        RAPI.AddItemToBlockQuadType(XLTV, RBlockQuadType.quad_table);
        RAPI.AddItemToBlockQuadType(XLTV, RBlockQuadType.quad_wall);

        request = assetbundle.LoadAssetAsync<Item_Base>("xxlraftsungtv_item");
        yield return request;
        Item_Base XXLTV = request.asset as Item_Base;
        XXLTV.settings_buildable.GetBlockPrefab(0).gameObject.AddComponent<CinemaScreen>();
        XXLTV.settings_buildable.GetBlockPrefab(1).gameObject.AddComponent<CinemaScreen>();
        RAPI.RegisterItem(XXLTV);
        RAPI.AddItemToBlockQuadType(XXLTV, RBlockQuadType.quad_floor);
        RAPI.AddItemToBlockQuadType(XXLTV, RBlockQuadType.quad_foundation);
        RAPI.AddItemToBlockQuadType(XXLTV, RBlockQuadType.quad_table);
        RAPI.AddItemToBlockQuadType(XXLTV, RBlockQuadType.quad_wall);

        request = assetbundle.LoadAssetAsync<Item_Base>("CinemaMod_Remote");
        yield return request;
        Item_Base CinemaRemote = request.asset as Item_Base;
        RAPI.RegisterItem(CinemaRemote);
        request = assetbundle.LoadAssetAsync<GameObject>("remote_prefab");
        yield return request;
        GameObject remote = request.asset as GameObject;
        remote.AddComponent<CinemaRemote>();
        RAPI.SetItemObject(CinemaRemote, remote);

        notification.Close();
        delayWorldLoading = false;
    }

    void Update()
    {
        if (RAPI.IsCurrentSceneMainMenu()) { return; }
        MessageHandler.ReadP2P_Channel_CinemaModAsync();

        if (Input.GetKeyDown("escape") && CinemaMod.isMenuShown)
        {
            CloseCinemaMenu();
        }
    }

    public static void OpenCinemaMenu(CinemaScreen screen)
    {
        if (screen == null) { return; }
        currentScreen = screen;
        menu.transform.Find("Background").Find("VolumeSlider").GetComponent<Slider>().value = screen.audiosource.volume;
        menu.transform.Find("Background").Find("VolumeSlider").Find("Value").GetComponent<TextMeshProUGUI>().text = Mathf.Round(screen.audiosource.volume * 100) + "%";
        menu.transform.Find("Background").Find("VolumeSlider").GetComponent<Slider>().onValueChanged.RemoveAllListeners();
        menu.transform.Find("Background").Find("VolumeSlider").GetComponent<Slider>().onValueChanged.AddListener((val) => { if (currentScreen != null) { currentScreen.SetVolume(val); menu.transform.Find("Background").Find("VolumeSlider").Find("Value").GetComponent<TextMeshProUGUI>().text = Mathf.Round(val * 100) + "%"; } });
        menu.transform.Find("Background").Find("YoutubeVideo").GetComponentInChildren<TMP_InputField>().text = "";
        menu.transform.Find("Background").Find("YoutubeVideo").GetComponentInChildren<Button>().onClick.RemoveAllListeners();
        menu.transform.Find("Background").Find("YoutubeVideo").GetComponentInChildren<Button>().onClick.AddListener(() => LoadYoutubeVideo(currentScreen));
        menu.transform.Find("Background").Find("TwitchStream").GetComponentInChildren<TMP_InputField>().text = "";
        menu.transform.Find("Background").Find("TwitchStream").GetComponentInChildren<Button>().onClick.RemoveAllListeners();
        menu.transform.Find("Background").Find("TwitchStream").GetComponentInChildren<Button>().onClick.AddListener(() => LoadTwitchStream());
        menu.transform.Find("Background").Find("NormalVideo").GetComponentInChildren<TMP_InputField>().text = "";
        menu.transform.Find("Background").Find("NormalVideo").GetComponentInChildren<Button>().onClick.RemoveAllListeners();
        menu.transform.Find("Background").Find("NormalVideo").GetComponentInChildren<Button>().onClick.AddListener(() => LoadNormalVideo());
        menu.GetComponent<CanvasGroup>().alpha = 1;
        menu.GetComponent<CanvasGroup>().interactable = true;
        menu.GetComponent<CanvasGroup>().blocksRaycasts = true;
        RAPI.ToggleCursor(true);
        isMenuShown = true;
    }

    public static bool IsYoutubeResponseValid(string response)
    {
        return response.Length > 100 && response != "" && response != "[]" && !response.StartsWith("<!DOCTYPE html>");
    }

    async static Task<string> getYTVideo(string url)
    {
        var youtube = new YoutubeClient();

        var vidManifest = await youtube.Videos.Streams.GetManifestAsync(url);
        var vidInfo = vidManifest.GetMuxedStreams().GetWithHighestVideoQuality();

        return vidInfo.Url;
    }

    public async static void LoadYoutubeVideo(CinemaScreen screen)
    {
        if (screen == null) { return; }
        CloseCinemaMenu();
        screen.isLoadingVideo = true;
        HNotification notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.spinning, "<color=#03bafc>Requesting Youtube Video...</color>");
        string url = menu.transform.Find("Background").Find("YoutubeVideo").GetComponentInChildren<TMP_InputField>().text;
        if (url.Length > 3)
        {
            string new_url = await getYTVideo(url);
            if (screen == null)
            {
                notification.Close();
                FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "The Cinema Screen can't be found!", 5, HNotify.ErrorSprite);
            }
            else
            {
                MessageHandler.SendMessage(new CMessage_SetVideo((Messages)MessageHandler.NetworkMessages.CinemaMod_SetVideo, screen.transform.position, url));
                screen.SetVideo(new_url);
                notification.Close();
                FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Youtube Video Found!", 5, HNotify.CheckSprite);
            }
        }
        else
        {
            notification.Close();
            FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Invalid Youtube URL!", 5, HNotify.ErrorSprite);
        }
        screen.isLoadingVideo = false;
    }

    public static void LoadTwitchStream()
    {
        if (currentScreen == null) { return; }


    }

    public static void LoadNormalVideo()
    {
        if (currentScreen == null) { return; }
        var url = menu.transform.Find("Background").Find("NormalVideo").GetComponentInChildren<TMP_InputField>().text;
        //TWITCH//
        if (url.ToLower().Contains("twitch.tv"))
        {
            Debug.Log("Twitch.Tv stream detected");
            string URL = "https://pwn.sh/tools/streamapi.py?url=" + url;
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(URL);
            request.ContentType = "application/json; charset=utf-8";
            request.PreAuthenticate = true;
            HttpWebResponse response = request.GetResponse() as HttpWebResponse;
            using (Stream responseStream = response.GetResponseStream())
            {
                StreamReader reader = new StreamReader(responseStream, Encoding.UTF8);
                var output = reader.ReadToEnd().Replace("p60", "p");
                //Debug.Log(output);
                var jsonObject = JObject.Parse(output);

                var streamURL = jsonObject.SelectToken("urls.720p").ToString();
                //Debug.Log(streamURL);
                MessageHandler.SendMessage(new CMessage_SetVideo((Messages)MessageHandler.NetworkMessages.CinemaMod_SetVideo, currentScreen.transform.position, menu.transform.Find("Background").Find("NormalVideo").GetComponentInChildren<TMP_InputField>().text));
                currentScreen.SetVideom3u8(streamURL);
            }

        }//END TWITCH//
        else
        {
            MessageHandler.SendMessage(new CMessage_SetVideo((Messages)MessageHandler.NetworkMessages.CinemaMod_SetVideo, currentScreen.transform.position, menu.transform.Find("Background").Find("NormalVideo").GetComponentInChildren<TMP_InputField>().text));
            currentScreen.SetVideo(url);
        }
    }

    public static void CloseCinemaMenu()
    {
        currentScreen = null;
        menu.GetComponent<CanvasGroup>().alpha = 0;
        menu.GetComponent<CanvasGroup>().interactable = false;
        menu.GetComponent<CanvasGroup>().blocksRaycasts = false;
        RAPI.ToggleCursor(false);
        isMenuShown = false;
    }
}

public class CinemaRemote : MonoBehaviour
{
    GameObject validLight;
    GameObject invalidLight;

    void Start()
    {
        validLight = transform.Find("CinemaRemoteModel").Find("ValidLight").gameObject;
        invalidLight = transform.Find("CinemaRemoteModel").Find("InvalidLight").gameObject;
        invalidLight.SetActive(false);
        validLight.SetActive(false);
    }

    void Update()
    {
        try
        {
            if (!GetComponentInParent<Network_Player>().IsLocalPlayer) { return; }
            if (CanvasHelper.ActiveMenu != MenuType.None) { return; }
            RaycastHit hit;
            if (Physics.Raycast(RAPI.GetLocalPlayer().Camera.transform.position, RAPI.GetLocalPlayer().Camera.transform.forward, out hit, 50, LayerMasks.MASK_Block))
            {
                CinemaScreen screen = hit.transform.GetComponentInParent<CinemaScreen>();
                if (screen == null)
                {
                    screen = hit.transform.GetComponentInChildren<CinemaScreen>();
                }
                validLight.SetActive(screen != null);
                invalidLight.SetActive(screen == null);
                if (screen != null && !CinemaMod.isMenuShown && !PlayerItemManager.IsBusy)
                {
                    if (Input.GetMouseButton(0))
                    {
                        CinemaMod.OpenCinemaMenu(screen);
                    }
                }
            }
            else
            {
                validLight.SetActive(false);
                invalidLight.SetActive(true);
            }
        }
        catch { }
    }
}

public class CinemaScreen : MonoBehaviour, IRaycastable
{
    public string currentUrl = "";
    public bool isLoadingVideo = false;
    public string hoverText = "Press E to open the cinema mod menu.";
    public RenderTexture rendertexture;
    public Material material;
    public AudioSource audiosource;
    public CanvasHelper canvas;
    public VideoPlayer videoplayer, otherCam;
    public bool showingText;
    public bool hasBeenPlaced;
    //TWITCH//
    Queue<string> urls;
    SlidingBuffer<String> playedChunks = new SlidingBuffer<string>(25);
    public static string m3u8;
    public float updateClip = 1f, updateFile = 6f;
    static Thread myThread;


    private void Vp_errorReceived(VideoPlayer source, string message)
    {
        //Debug.Log("Playback preparation failed. " + message, source);
    }

    private void Vp_prepareCompleted(VideoPlayer source)
    {
        //Debug.Log("Clip Prepared " + source.url);
        //source.Play();
    }

    void UpdateClip()
    {
        //Debug.Log("Video Time: " + videoplayer.time);
        //Debug.Log("Count: " + urls.Count);
        if (videoplayer.isPlaying)
        {
            //Debug.Log("Player is playing");
        }
        else
        {
            //Debug.Log("Player has stopped");
        }

        if (urls.Count > 0)
        {
            videoplayer.url = urls.Dequeue();
            videoplayer.Prepare();
        }

        StartCoroutine(UpdateFile());

    }


    IEnumerator UpdateFile()
    {
        while (true)
        {
            System.Random rnd = new System.Random();
            int num = rnd.Next();
            //Debug.Log("&t=" + num);
            UnityEngine.Networking.UnityWebRequest www = UnityEngine.Networking.UnityWebRequest.Get(m3u8 + "&t=" + num);
            yield return www.SendWebRequest();

            if (www.isNetworkError || www.isHttpError)
            {
                Debug.Log("UpdateFile: " + www.error);
            }
            else
            {
                string[] raw = www.downloadHandler.text.Split('\n');
                foreach (string line in raw)
                {
                    if (line.StartsWith("https://"))
                    {
                        if (!playedChunks.Contains(line))
                        {
                            playedChunks.Add(line);
                            urls.Enqueue(line);
                            //Debug.Log("Adding " + line);
                        }
                        else
                        {
                            //Debug.Log("Skipping duplicate chunk " + line);
                        }

                    }
                }
            }

            yield return new WaitForSeconds(updateFile);
            //Debug.Log("Method is executed");
        }
    }

    public void Playm3u8()
    {
        StartCoroutine(UpdateFile());
        InvokeRepeating("UpdateClip", updateClip, updateClip);
        urls = new Queue<string>();
        videoplayer.prepareCompleted += Vp_prepareCompleted;
        videoplayer.errorReceived += Vp_errorReceived;
    }

    public void SetVideom3u8(string url)
    {
        m3u8 = url;
        Stop();
        Playm3u8();
    }

    //END TWITCH//

    public void Start()
    {
        canvas = ComponentManager<CanvasHelper>.Value;
        videoplayer = GetComponentInChildren<VideoPlayer>();
        audiosource = GetComponentInChildren<AudioSource>();
        videoplayer.loopPointReached += EndReached;
    }

    void EndReached(UnityEngine.Video.VideoPlayer vp)
    {
        //Debug.Log("Clip Ended");
        //vp.playbackSpeed = vp.playbackSpeed / 1.0F;
    }

    public void CreateRenderTexture()
    {
        if (rendertexture == null || !rendertexture.IsCreated())
        {
            rendertexture = new RenderTexture(1280, 720, 0);
            rendertexture.Create();
        }
        rendertexture.Release();
        if (material == null)
        {
            material = new Material(CinemaMod.novideoMaterial.shader);
        }
        material.mainTexture = rendertexture;
        transform.Find("CinemaScreen").GetComponent<Renderer>().material = material;
        videoplayer.targetTexture = rendertexture;
    }

    public void Pause()
    {
        videoplayer.Pause();
    }

    public void Play()
    {
        videoplayer.Play();
    }

    public void Stop()
    {
        videoplayer.url = "";
        videoplayer.Stop();
        videoplayer.clip = null;

        CancelInvoke();
        StopAllCoroutines();
        videoplayer.prepareCompleted -= Vp_prepareCompleted;
        videoplayer.errorReceived -= Vp_errorReceived;

        CreateRenderTexture();
    }

    public void SetVideo(string url)
    {
        Stop();
        videoplayer.url = url;
        videoplayer.Play();
    }

    public void SetVolume(float _volume)
    {
        audiosource.volume = Mathf.Clamp(_volume, 0, 1);
    }

    private void OnBlockPlaced()
    {
        hasBeenPlaced = true;
    }

    public void OnIsRayed()
    {
        if (!hasBeenPlaced) { return; }
        if (canvas == null)
        {
            canvas = ComponentManager<CanvasHelper>.Value;
            return;
        }
        if (CanvasHelper.ActiveMenu != MenuType.None || !Helper.LocalPlayerIsWithinDistance(transform.position, Player.UseDistance))
        {
            if (showingText)
            {
                canvas.displayTextManager.HideDisplayTexts();
                showingText = false;
            }
            return;
        }
        else
        {
            canvas.displayTextManager.ShowText(isLoadingVideo ? "Loading Video..." : hoverText, 0, true, 0);
            showingText = true;
            if (isLoadingVideo) { return; }
            if (Input.GetKeyDown(KeyCode.E))
            {
                CinemaMod.OpenCinemaMenu(this);
            }
        }
        return;
    }

    public void OnRayEnter() { }

    public void OnRayExit()
    {
        if (showingText)
        {
            canvas.displayTextManager.HideDisplayTexts();
            showingText = false;
        }
    }
}

[Serializable]
public class YoutubeDataBackup
{
    public string url;
    public int itag;
    public string format;
}

public class MessageHandler : MonoBehaviour
{
    public enum NetworkMessages
    {
        CinemaMod_SetVideo = 6000,
        CinemaMod_Stop = 6001,
        CinemaMod_Pause = 6002,
        CinemaMod_Play = 6003
    }

    public static void SendMessage(Message message)
    {
        if (Raft_Network.IsHost)
        {
            RAPI.GetLocalPlayer().Network.RPC(message, Target.Other, EP2PSend.k_EP2PSendReliable, (NetworkChannel)70);
        }
        else
        {
            RAPI.GetLocalPlayer().SendP2P(message, EP2PSend.k_EP2PSendReliable, (NetworkChannel)70);
        }
    }

    public static CinemaScreen FindClosestCinemaScreen(Vector3 point)
    {
        CinemaScreen closestScreen = null;
        float closestDistance = Mathf.Infinity;

        CinemaScreen[] allScreens = FindObjectsOfType<CinemaScreen>();
        foreach (CinemaScreen screen in allScreens)
        {
            float distance = Vector3.Distance(point, screen.transform.position);
            if (distance < closestDistance)
            {
                closestScreen = screen;
                closestDistance = distance;
            }
        }
        return closestScreen;
    }

    public static async void ReadP2P_Channel_CinemaModAsync()
    {
        if (RAPI.IsCurrentSceneMainMenu()) { return; }
        NetworkMessage netMessage = RAPI.ListenForNetworkMessagesOnChannel(70);
        if (netMessage != null)
        {
            CSteamID id = netMessage.steamid;
            Message message = netMessage.message;
            switch (message.Type)
            {
                case (Messages)NetworkMessages.CinemaMod_SetVideo:
                    {
                        CMessage_SetVideo msg = message as CMessage_SetVideo;

                        CinemaScreen cs = FindClosestCinemaScreen(msg.position);
                        if (cs == null || Vector3.Distance(cs.transform.position, msg.position) > 2f)
                        {
                            //Debug.LogError("/!\\ CAN'T FIND CINEMA SCREEN AT POSITION " + msg.position + " /!\\");
                            break;
                        }

                        if (msg.url.Contains("youtube") || msg.url.Contains("youtu.be"))
                        {
                            string new_url = await getYTVideoAsync(msg.url);
                            cs.SetVideo(new_url);
                        }
                        else
                        {
                            cs.SetVideo(msg.url);
                        }
                        break;
                    }
                case (Messages)NetworkMessages.CinemaMod_Stop:
                    {
                        CMessage_CinemaModPosition msg = message as CMessage_CinemaModPosition;
                        CinemaScreen cs = FindClosestCinemaScreen(msg.position);
                        if (cs == null || Vector3.Distance(cs.transform.position, msg.position) > 2f)
                        {
                            //Debug.LogError("/!\\ CAN'T FIND CINEMA SCREEN AT POSITION " + msg.position + " /!\\");
                            break;
                        }
                        cs.Stop();
                        break;
                    }
                case (Messages)NetworkMessages.CinemaMod_Pause:
                    {
                        CMessage_CinemaModPosition msg = message as CMessage_CinemaModPosition;
                        CinemaScreen cs = FindClosestCinemaScreen(msg.position);
                        if (cs == null || Vector3.Distance(cs.transform.position, msg.position) > 2f)
                        {
                            //Debug.LogError("/!\\ CAN'T FIND CINEMA SCREEN AT POSITION " + msg.position + " /!\\");
                            break;
                        }
                        cs.Pause();
                        break;
                    }
                case (Messages)NetworkMessages.CinemaMod_Play:
                    {
                        CMessage_CinemaModPosition msg = message as CMessage_CinemaModPosition;
                        CinemaScreen cs = FindClosestCinemaScreen(msg.position);
                        if (cs == null || Vector3.Distance(cs.transform.position, msg.position) > 2f)
                        {
                            //Debug.LogError("/!\\ CAN'T FIND CINEMA SCREEN AT POSITION " + msg.position + " /!\\");
                            break;
                        }
                        cs.Play();
                        break;
                    }
            }
        }
    }

    private static async Task<string> getYTVideoAsync(String url)
    {
        var youtube = new YoutubeClient();

        var vidManifest = await youtube.Videos.Streams.GetManifestAsync(url);
        var vidInfo = vidManifest.GetMuxedStreams().GetWithHighestVideoQuality();

        return vidInfo.Url;
    }
}

[Serializable]
public class JsonRetData
{
    public string url;
    public Boolean error;
}

[Serializable]
public class CMessage_SetVideo : Message
{
    public Vector3 position { get { return new Vector3(posX, posY, posZ); } private set { posX = value.x; posY = value.y; posZ = value.z; } }
    public float posX, posY, posZ;
    public string url;

    public CMessage_SetVideo(Messages type, Vector3 _position, string _url) : base(type)
    {
        position = _position;
        url = _url;
    }
}

[Serializable]
public class CMessage_CinemaModPosition : Message
{
    public Vector3 position { get { return new Vector3(posX, posY, posZ); } private set { posX = value.x; posY = value.y; posZ = value.z; } }
    public float posX, posY, posZ;

    public CMessage_CinemaModPosition(Messages type, Vector3 _position) : base(type)
    {
        position = _position;
    }
}

sealed class PreMergeToMergedDeserializationBinder : SerializationBinder
{
    public override Type BindToType(string assemblyName, string typeName)
    {
        Type typeToDeserialize = null;
        String exeAssembly = Assembly.GetExecutingAssembly().FullName;
        typeToDeserialize = Type.GetType(String.Format("{0}, {1}", typeName, exeAssembly));
        return typeToDeserialize;
    }
}

class SlidingBuffer<T> : IEnumerable<T>
{
    private readonly Queue<T> _queue;
    private readonly int _maxCount;

    public SlidingBuffer(int maxCount)
    {
        _maxCount = maxCount;
        _queue = new Queue<T>(maxCount);
    }

    public void Add(T item)
    {
        if (_queue.Count == _maxCount)
            _queue.Dequeue();
        _queue.Enqueue(item);
    }

    public IEnumerator<T> GetEnumerator()
    {
        return _queue.GetEnumerator();
    }

    IEnumerator IEnumerable.GetEnumerator()
    {
        return GetEnumerator();
    }
}